import java.awt.*; import java.io.*; import java.awt.image.*;
import javax.swing.*; import java.util.*;
/*
  Entity.java
  (c)1999-2008 SSC Development Team
  Function: Storing Entity Statistics
  - This file only contains basic functions. Advanced statistics operations are
    performed in Stats.java.
  Allowed Dependencies: Sprite.java, Spell.java
*/

public class Entity
{
  private Sprite sprite;
  public Sprite getSprite() { return sprite; }
  public void setSprite(Sprite a) { sprite = a; }


  /* TODO: Arrange proper permissions here */
  public String name, classname;
  public Image[] img_attack;
  public Image portrait;

  public void addAtkImages(String[] imgs) {

  img_attack = new Image[imgs.length];

  for(int i=0; i<imgs.length; i++) {
    img_attack[i]=Lib_Image.getImage(imgs[i]);
    }

  }

  /* Creates a new array, copies the existing array of attack images
   * and appends a single image to it */
  public void addAtkImage(String img) {
	  Image[] temp;
	  int limit;

	  if(img_attack != null) {
		temp = new Image[img_attack.length + 1];
		for(int i=0; i<temp.length-1; i++) {
		  temp[i]=img_attack[i];
		}
	  }
	  else {
		temp = new Image[1];
	  }

	  temp[temp.length-1] = Lib_Image.getImage(img);
	  this.img_attack = temp;
	  //System.out.println(this.name+": "+temp.length+" :"+img+":");
  }



  public Spell[] spell = new Spell[4];

  public int x; //x location in pixels
  public int y; //y location in pixels
  public int f; //frame

  public int curhp, maxhp;     /* Hit Points   (1+)  */
  public int curmp, maxmp;     /* Magic Points (0+)  */

  public int level, exp;       /* Level & Experience */

  int att;    /* Base hit %   (0+) */
  int dod;    /* Base dodge % (0+) */
  int range;  /* Attack Range (1+)*/
  int spellres; /* Spell resistance */

  int mindam; /* Total min damage   (1+) */
  int damran; /* Total damage range (0+) */
  int armor;  /* Damage reduction   (0+) */

  /* Talents: all rated from 1-10 */
  public int strength;
  public int precision;
  public int reflexes;
  public int endurance;
  public int speed;
  public int willpower;

  /*Items*/
  public String item1;
  public String item2;
  public String item3;
  public String item4;

  public String weptype;

  /* Determines if the Entity interacts with adjacent players */
  public boolean responsive;
  public String resptext; //text spoken as response
  public String respevent; //response event

  /* A.I. related variables */
  public boolean ai;

  public int backstab; /* Backstab damage multiplier (in %) */
  /*
   * 110% should be normal
   * 120%+ is cool for special classes :)
   */

  public int move; /* Movement  (0-10) */
  public int faction; /* Allegiance */
  /* 0  = neutral
   * 1  = player
   * 2  = enemy
   * 3+ = other groups?
   */

  public Entity(Sprite a) {
  	this.sprite = a;
    this.backstab = 110;
    this.range = 1;
    this.responsive = false;
  }

  public Entity(Sprite a, int tilex, int tiley) {
    this.sprite = a;
    this.x = tilex*24;
    this.y = tiley*24;
    this.f = 4;
    this.faction = 1;
    this.range = 1;
    this.backstab = 110;
    this.responsive = false;
  }
}
