import javax.sound.midi.*;
import java.io.*;
import java.util.*;

/*
  JukeBox.java
    (c)1999-2004 SSC Development Team
  Functions:
  -Managing background music
  Allowed Dependencies: None
*/

public class JukeBox {

  private static Sequence b_seq, w_seq;
  private static Sequencer sequencer;
  private static long walkaboutpos;


  public static void PlayBattleTune()
  {
    walkaboutpos = sequencer.getTickPosition();

    sequencer.stop();

    // Start playing
    try {

      sequencer.setSequence(b_seq);

    }
    catch (InvalidMidiDataException e) {
    }
    if(Buffer.MusicOn) {
      sequencer.start();
    }
  }

  public static void PlayWalkTune(){
    sequencer.stop();

    // Start playing
    try {
	  w_seq = MidiSystem.getSequence(new File(Buffer.currentMusic));
      sequencer.setSequence(w_seq);
      sequencer.setLoopCount(sequencer.LOOP_CONTINUOUSLY);
    } catch (IOException e) {}
    catch (InvalidMidiDataException e) {}

    sequencer.setTickPosition(walkaboutpos);

    if(Buffer.MusicOn)
    {
      sequencer.start();
    }
  }

  public static void StopAll() {
    sequencer.stop();
    sequencer.setMicrosecondPosition(0);
  }

  public static void Init() {
    try {
      // From file
      b_seq = MidiSystem.getSequence(new File("music/battle.mid"));

      // Create a sequencer for the sequence
      sequencer = MidiSystem.getSequencer();
      sequencer.setLoopCount(sequencer.LOOP_CONTINUOUSLY);
      sequencer.open();

    } catch (IOException e) {
    } catch (MidiUnavailableException e) {
    } catch (InvalidMidiDataException e) {
    }

    try {
      // From file
      w_seq = MidiSystem.getSequence(new File(Buffer.currentMusic));

      // Create a sequencer for the sequence
      sequencer = MidiSystem.getSequencer();
      sequencer.open();
      sequencer.setSequence(w_seq);
    } catch (IOException e) {
    } catch (MidiUnavailableException e) {
    } catch (InvalidMidiDataException e) {
    }

    walkaboutpos = 0;
  }

  public JukeBox() {

  }
}
