import java.util.*; import java.awt.*; import java.io.*; import java.awt.image.*;
import javax.swing.*;

/*
  Lib_Map.java
  (c)1999-2008 SSC Development Team
  Function: Managing map and map transition related methods.
  Allowed Dependencies: None
*/

public class Lib_Map
{

  public static BattleFrame b;
  public static WalkFrame w;
  public static MovieFrame m;

  //mode 0 is old battle map
  //mode 1 is old walkabout map
  public static void initMap(int mode, JFrame context, String mapname){
	Buffer.mapFile=null;
	Buffer.frameFile=null;
	Buffer.entityFile=null;

    int type = Lib_Util.loadMap(mapname);

    if(mode == 0 && type == 0) {
      ((BattleFrame)context).init();
    }
    else if(mode == 1 && type == 1) {
      ((WalkFrame)context).init();
    }
    else if(mode == 2 && type == 2) {
      ((MovieFrame)context).init(Buffer.movieTicks,Buffer.movieFrames);
    }
    else if(type == 0) {
      b = new BattleFrame(Buffer.getCurMap());
      b.setTitle("Shiny Sword");
      //main.setSize(365, 265);
      b.setSize((int)(360*Buffer.ScaleRatio+5), (int)(240*Buffer.ScaleRatio+25));
      b.setResizable(false);
      b.setVisible(true);

      JukeBox.PlayWalkTune();
    }
    else if(type == 1) {
      w = new WalkFrame(Buffer.getCurMap());
      w.setTitle("Shiny Sword");
      //main.setSize(365, 265);
      w.setSize((int)(360*Buffer.ScaleRatio+5), (int)(240*Buffer.ScaleRatio+25));
      w.setResizable(false);
      w.setVisible(true);

      JukeBox.PlayWalkTune();
    }
    else if(type == 2) {
		//include movieticks int[] and movieframes=string[] in constructor call.

	  m = new MovieFrame(Buffer.movieTicks,Buffer.movieFrames);
	  m.setTitle("Shiny Sword");
	  m.setSize((int)(360*Buffer.ScaleRatio+5), (int)(240*Buffer.ScaleRatio+25));
      m.setResizable(false);
      m.setVisible(true);

      JukeBox.PlayWalkTune();
	}
  }

  /* Execute Zones */
  public static void execZone(int zonenum, WalkFrame master) {

    if(zonenum < 1) return;

    if(Buffer.cur_script == null) {
      System.out.println("Error: The map script has not been buffered.");
      return;
    }

    String type = Buffer.cur_script.getProperty("zone."+zonenum+".type");
    if(type == null) {
      System.out.println("Error: Zone "+zonenum+" has no defined type. Ignoring...");
      return;
    }
    else if(type.equals("mapswitch")) {
      String target = Buffer.cur_script.getProperty("zone."+zonenum+".target");
      if(target == null) {
        System.out.println("Error: Zone "+zonenum+" has no target map defined for the mapswitch. Ignoring...");
        return;
      }
      /* Execute Map Switch */
      master.SwitchMap(target);
    }
  }

}