import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/*
  MovieFrame.java
    (c)1999-2008 SSC Development Team
  Functions:
  -Managing the Game Movie Guis as a whole(intro, credits etc).
  Allowed Dependencies: MoviePanel.java
*/

public class MovieFrame  extends JFrame implements  ActionListener, KeyListener, WindowFocusListener
{
  Container c = getContentPane();

  Timer timer;
  private JTextField prompt;

  MoviePanel screen;

  /* Value overview of directionals:
   *
   * 0 not moving up
   * 1 moving up, and the corresponding arrow key is still being pressed.
   * 2 moving up, but the key has been released.
   * 3 arrow key has been pressed, but other movement directions
   *   override this one
   */

  private int up = 0;
  private int down = 0;
  private int left = 0;
  private int right = 0;

  /*equals 1 if particular button was once pressed and not released yet.*/
  private int opup = 0;
  private int opdown = 0;
  private int opleft = 0;
  private int opright = 0;

  /* Mode var:
   * 0 = just walking around.
   * 1 = talking to nearest entity
   */
  private static int tempmode=0;
  public static int Tempmode() {
    return tempmode;
  }

  private static int mode = 0;
  public static int Mode() {
    return mode;
  }

  /* Flags Adder!! */
  private static String tempresp = "";
  public static String TempResp() {
    return tempresp;
  }

  /* Constructor */
  public MovieFrame(int[] movieTicks, String[] movieFrames)
  {
    this.setVisible(false);

	//movieticks for timing, not implemented yet.
	//movie frames are the names of the files, called from entityfile.

    screen = new MoviePanel(movieTicks, movieFrames);

    timer = new Timer(Buffer.TimerDelay, this); //Timer delay.TWEAKABLE
    prompt = new JTextField("");

    screen.setBounds(0,0,(int)(360*Buffer.ScaleRatio),(int)(240*Buffer.ScaleRatio));

    c.setLayout(null);

    c.add(screen);
    c.add(prompt);

    prompt.addKeyListener(this);
    this.addWindowFocusListener(this);

    this.setVisible(true);
    startAnimation();
  }

  /* initialization after map switches */

  public void init(int[] movieTicks, String[] movieFrames) {
    screen = new MoviePanel(movieTicks, movieFrames);

    Timer timer = new Timer(Buffer.TimerDelay, this); //Timer delay. TWEAKABLE
    JTextField prompt = new JTextField("");

    screen.setBounds(0,0,(int)(360*Buffer.ScaleRatio),(int)(240*Buffer.ScaleRatio));

    c.setLayout(null);

    c.add(screen);
    c.add(prompt);

    JukeBox.Init();

    prompt.addKeyListener(this);
    this.addWindowFocusListener(this);

    this.setVisible(true);

    JukeBox.PlayWalkTune();
    startAnimation();
  }

  /* Switch to a different map! */

  public void SwitchMap(String mapname)
  {
    stopAnimation();
    JukeBox.StopAll();
    this.setVisible(false);

    Buffer.firstPlayer();

    c.remove(screen);
    c.remove(prompt);

    Lib_Map.initMap(2,this,mapname);


  }

  public synchronized void startAnimation() {
    timer.start();
  }


  public synchronized void stopAnimation() {
    timer.stop();
  }

  private int anim_delay = Buffer.AnimDelay; //Animation delay per frame. TWEAKABLE
  private int anim_iterator = 0;

  /*
   * DRAWING ROUTINE
   */

  public int chk1(int a) //tiny math
  {
    if(a == 1) { return(1); }
    return(0);
  }

  public void actionPerformed(ActionEvent e) {

    //tile & sprite animation
    anim_iterator++;
    if(anim_iterator>=anim_delay) {
      anim_iterator = 0;
    }

    int newdirection = 0;

    //block next movement if obstructed!

    //Map repaint
    screen.repaint();

  }

  /*
   * KEYBOARD BUTTON HANDLING
   */

  public void keyPressed(KeyEvent e) {

    /* key becomes "VK_<something>" */
    int key = e.getKeyCode();

    /* Arrow keys initiate movement by queueing direction*/


	/* Intro controls */
	if(key == e.VK_UP && up != 1) {
	 }
	else if(key == e.VK_DOWN && down != 1) {
	}
	else if(key == e.VK_LEFT && left != 1) {
	}
	else if(key == e.VK_RIGHT && right != 1) {
	 }
	else if(key == e.VK_N) {
	SwitchMap(Buffer.nextMap);
	}


     /*
     * SSC is not a browser, but F5 does invoke a screen refresh.
     * Just in case really ;)
     */
    if(key == e.VK_F5)
    {
      this.paint(this.getGraphics());
    }
    //if(key == e.VK_ENTER)
    else if(key == e.VK_A || key == e.VK_D)
    {
	 MoviePanel.Update(this);
    }
    else if(key == e.VK_S) // Cancel button
    {

    }
    else if(key == e.VK_F && mode  == 0)
    {

    }

  }

  public void keyTyped(KeyEvent e) { }
  public void keyReleased(KeyEvent e) {

    int key = e.getKeyCode();

    //Releasing the arrow keys stops any future movement in that direction,
    //but finishes the current move to the next tile

    if(key == e.VK_UP) {
    }

    if(key == e.VK_DOWN) {
    }

    if(key == e.VK_LEFT) {
    }

    if(key == e.VK_RIGHT) {
    }

  }

  public void Refocus()
  {
    prompt.requestFocus();
  }

  /*Start animation routine on focus*/
  public void windowGainedFocus(WindowEvent e)
  {
    timer.start();
  }

  /*Halt animation routine on unfocus*/
  public void windowLostFocus(WindowEvent e) { timer.stop(); }
}

