
import java.awt.*; import javax.swing.*; import java.io.*; import java.util.*;


/*
  MoviePanel.java
    (c)1999-2008 SSC Development Team
  Functions:
  -Rendering the movie and associated functions.
  Allowed Dependencies: Shiny_Sword.java, Libs.
*/

public class MoviePanel extends JPanel
{
  //some variable to determine which movie to play
  private static Image[] mFrames;
  private static int currentFrame;

  public MoviePanel(int[] movieTicks, String[] movieFrames) {
	  //movieTicks is 0 = user controlled(wait for update to be called
	  //but anything > 1 should be a tick of time, so "movies" could be played...
	  //possibly useable for credits, but not implemented yet.

	currentFrame=0;
    this.setBackground(new Color((float) 0.0, (float) 0.0, (float) 0.0));

    mFrames=new Image[movieFrames.length];

    for(int i=0;i<movieFrames.length;i++){
		mFrames[i]=Lib_Image.getImage(movieFrames[i]);
	}


  }

  public static void Update(MovieFrame m) {
	if(currentFrame<(mFrames.length-1)){
	    currentFrame++;
	} else {
		m.SwitchMap(Buffer.nextMap);
	}
  }

  public void paintComponent(Graphics g) {

      super.paintComponent(g);
      g.setFont(Buffer.normaltxt);
      if(Buffer.ScaleRatio != 1.0) {
        ((Graphics2D) g).scale(Buffer.ScaleRatio,Buffer.ScaleRatio);
      }

	  //All drawing should be done under here so it is scaled properly.

	  g.drawImage(mFrames[currentFrame], 0, 0, null);


  }

}
