import java.awt.*; import javax.swing.*; import java.awt.event.*; 
import java.util.*;

/*
	Palette.java 
	(c)1999-2003 SSC Development Team
	Function: Managing the palette.
	Allowed Dependencies: None	
*/

public class Palette extends JPanel implements MouseListener
{
    // These are the methods that must be implemented
    // in order to create a color chooser panel.
    	
   	private Vector<Color> colors = new Vector<Color>();
    	 	    	
    public Palette() {
            
	      //OOgly Transparent Hot Pink ;)
        colors.addElement(new Color(255,0,255,0));
	      
	      //Grays
        for(int i=0;i<20;i++)
        {
            colors.addElement(new Color((255*i)/20,(255*i)/20,(255*i)/20));	
        } 
            
        //Blues
        for(int i=0;i<10;i++)
        {
            colors.addElement(new Color(255-((255*i)/10),255-((255*i)/10),255));	
        }   
        for(int i=0;i<10;i++)
        {
            colors.addElement(new Color(0,0,255-((255*i)/10)));	
        }  
              
        //Greens            
        for(int i=0;i<10;i++)
        {
            colors.addElement(new Color(0,(255*i)/10,0));	
        }             
        for(int i=0;i<10;i++)
        {
            colors.addElement(new Color((255*i)/10,255,(255*i)/10));	
        }    
            
        //Reds
        for(int i=0;i<10;i++)
        {
            colors.addElement(new Color(255,255-((255*i)/10),255-((255*i)/10)));	
        } 
        for(int i=0;i<10;i++)
        {
            colors.addElement(new Color(255-((255*i)/10),0,0));	
        }     

	      //Browns
        for(int i=0;i<15;i++)
        {
            colors.addElement(new Color(32+((223*i)/15),32+((223*i)/15),0));	
        }  
        for(int i=0;i<5;i++)
        {
            colors.addElement(new Color(255,255,(255*i)/5));	
        } 
            
        //Others
        for(int i=0;i<10;i++)
        {
            colors.addElement(new Color(223-((223*i)/10),223-((223*i)/10),128-((128*i)/10)));	
        }
        for(int i=0;i<10;i++)
        {
            colors.addElement(new Color(128-((128*i)/10),223-((223*i)/10),223-((223*i)/10)));	
        }                                                       
                                      
    }    

  public void paintComponent(Graphics g) {
	
	  this.removeMouseListener(this);
	
    super.paintComponent(g);
                      		
	  for(int i=0; i<colors.size(); i++)
		{	
		  g.setColor((Color) colors.get(i));
		  g.fillRect((i%20)*10,(i/20)*10,10,10);
		}
		
	  g.setColor(Buffer.getCurColor(0));
	  g.fillRect(10,80,10,10);
	
    g.setColor(Buffer.getCurColor(1));
    g.fillRect(20,80,10,10);
	
	  this.addMouseListener(this);
	}

	public void mousePressed(MouseEvent e) {
      int index = (e.getX()/10) + (e.getY()/10)*20;
    	
    	if(index<colors.size()) {
    		//changes tile value whenever clicked.
    		if(e.getButton() == e.BUTTON1) {
    			Buffer.setCurColor((Color) colors.get(index),0);
    		}
        else if(e.getButton() == e.BUTTON3) {
          Buffer.setCurColor((Color) colors.get(index),1);
        }
			this.repaint();
		}
    }

  public void mouseReleased(MouseEvent e) {    }

  public void mouseEntered(MouseEvent e) {    }

  public void mouseExited(MouseEvent e) {    }

  public void mouseClicked(MouseEvent e) {	}
    
  public void mouseDragged(MouseEvent e) {   	}

}
