import java.awt.*; import java.io.*; import java.awt.image.*;
import javax.swing.*; import java.util.*;
/*
	Sprite.java
  	(c)1999-2003 SSC Development Team
	Function: Managing sprite graphics and related statistics.
	Allowed Dependencies: Lib_Image.java
*/

public class Sprite
{
	private Vector<BufferedImage> frames;
	
	/* Constructor: Sprites can be loaded directly from images
	 * TODO: Make sprites also _saveable to images!
	 */
	public Sprite(String sourcefile) 
	{
		frames = new Vector<BufferedImage>();
		Image sourceimg = new ImageIcon(sourcefile).getImage();
		int height = 4;
		int width = 2;
		
		if(sourceimg.getHeight(null)<100) { System.out.println("Error loading spritefile: The sourcefile has height < 100!\n"); }
		else if(sourceimg.getWidth(null)<50) { System.out.println("Error loading spritefile: The sourcefile has height < 50!\n"); }
		else {
			
			/* Copying parts of sourceimg to the frames vector */
    		
    		for(int j=0;j<height;j++) {
    			for(int i=0;i<width;i++) {
    				frames.addElement(Lib_Image.cropImage(sourceimg, i*25, j*25, 24, 24)); 
    			}
    		}
    	}	
	}
	
	/*direction overview:
	 *"n" = north = frame 0-1
	 *"e" = east  = frame 2-3
	 *"s" = south = frame 4-5
	 *"w" = west  = frame 6-7
	 *TODO: Add section for "specials".
	 */
	 
	/* Returns a specific frame graphic */ 
	public Image getFrame(int number) 
	{
		if(number<= frames.size()) {
			return((BufferedImage) frames.elementAt(number));
		}	

		System.out.println("Error returning frame #"+number+" from Sprite: The frame does not exist.");
		return null;
	} 
		
}