import java.awt.*; import javax.swing.*; import java.io.*; import java.util.*; 
import java.awt.event.*;

/*
	TileViewPanel.java
  	(c)1999-2002 SSC Development Team
	Functions: 
	-Rendering the tile viewer.
	Allowed Dependencies: Any
*/

public class TileViewPanel extends JPanel implements MouseListener, MouseMotionListener
{
  Graphics g;
  int lr;
  public int pf;

  public void paintComponent(Graphics g) {
	  this.removeMouseListener(this);
	  this.g = g;
		
    super.paintComponent(g);

	  g.fillRect(0,0,240,240);
    g.drawImage(Buffer.getTile(Buffer.getCurTile()),0,0,240,240,this);
  		
  	this.addMouseListener(this);
  	this.addMouseMotionListener(this);
  }	

  /* Pixel Bucketfill algorithm */
  public void bucketFill(Color c, int x, int y) {
    
    Buffer.getTile(Buffer.getCurTile()).setRGB(x,y,Buffer.getCurColor(lr).getRGB());
    Buffer.getCurMap().getTileset().setTile(Buffer.getCurTile(),new Tile(Buffer.getTile(Buffer.getCurTile())));
    
    if(x<23 && Buffer.getTile(Buffer.getCurTile()).getRGB(x+1,y) == c.getRGB()) {
      bucketFill(c,x+1,y);
    }
    if(x>0 && Buffer.getTile(Buffer.getCurTile()).getRGB(x-1,y) == c.getRGB()) {
      bucketFill(c,x-1,y);
    }
    if(y<23 && Buffer.getTile(Buffer.getCurTile()).getRGB(x,y+1) == c.getRGB()) {
      bucketFill(c,x,y+1);
    }
    if(y>0 && Buffer.getTile(Buffer.getCurTile()).getRGB(x,y-1) == c.getRGB()) {
      bucketFill(c,x,y-1);
    }
  }
    
	public void mousePressed(MouseEvent e) {
      int x = (e.getX()/10);
      int y = (e.getY()/10);
      
      if(e.getButton() == e.BUTTON3) {
        lr = 1;
      }
      if(e.getButton() == e.BUTTON1) {
        lr = 0;
      }
             
      if(Buffer.getTile(Buffer.getCurTile()).getRGB(x,y) != Buffer.getCurColor(lr).getRGB()) {
        
        /* Paint action */
        if(this.pf == 0) {
        
          //Update the tile in the buffer
          Buffer.getTile(Buffer.getCurTile()).setRGB(x,y,Buffer.getCurColor(lr).getRGB());
      
          //Update the tile in the data structure
          Buffer.getCurMap().getTileset().setTile(Buffer.getCurTile(),new Tile(Buffer.getTile(Buffer.getCurTile())));
      
          this.repaint();       
        } 
        /* Bucketfill action */
        else if(this.pf == 1) {
          Color c = new Color(Buffer.getTile(Buffer.getCurTile()).getRGB(x,y));
          
          bucketFill(c, x, y);          
      
          this.repaint(); 
        }       
      } 
    }

    public void mouseReleased(MouseEvent e) {    }

    public void mouseEntered(MouseEvent e) {    }

    public void mouseExited(MouseEvent e) {    }

    public void mouseClicked(MouseEvent e) {	}
      
    public void mouseDragged(MouseEvent e) {   	
  		int x = (e.getX()/10);
      int y = (e.getY()/10);  
		

		
		  if(x>=0 && y>=0 && x<24 && y<24) {
    	  if(Buffer.getTile(Buffer.getCurTile()).getRGB(x,y) != Buffer.getCurColor(lr).getRGB()) {
   		    
   		    /* Paint action */
   		    if(this.pf == 0) {
   		    
   		      //Update the tile in the buffer
        	  Buffer.getTile(Buffer.getCurTile()).setRGB(x,y,Buffer.getCurColor(lr).getRGB());
        
        	  //Update the tile in the data structure
        	  Buffer.getCurMap().getTileset().setTile(Buffer.getCurTile(),new Tile(Buffer.getTile(Buffer.getCurTile())));
        
            this.repaint();    		
          } 
          /* Bucketfill action */
          else if(this.pf == 1) {
            Color c = new Color(Buffer.getTile(Buffer.getCurTile()).getRGB(x,y));
            
            bucketFill(c, x, y);          
        
            this.repaint(); 
          }
          
    	  } 
    	}
    }	
      
    public void mouseMoved(MouseEvent e)  {	}
}